import { Company } from './../../shared/models/company/company.model';
import { CompanyActionTypes } from './company.action.type';
import { Action } from '@ngrx/store';

//create form to add new company
export class CreateFormAddCompanyAction implements Action{
  type: CompanyActionTypes = CompanyActionTypes.CREATE_FORM_ADD_COMPANY;
  constructor(public payload: any){}
}
export class CreateFormAddCompanyActionSuccess implements Action{
  type: CompanyActionTypes = CompanyActionTypes.CREATE_FORM_ADD_COMPANY_SUCCESS;
  constructor(public payload: any){}
}
export class CreateFormAddCompanyActionError implements Action{
  type: CompanyActionTypes = CompanyActionTypes.CREATE_FORM_ADD_COMPANY_ERROR;
  constructor(public payload: string){}
}

// save new company
export class SaveNewCompanyAction implements Action{
  type: CompanyActionTypes = CompanyActionTypes.SAVE_NEW_CAMPANY;
  constructor(public payload: Company){}
}
export class SaveNewCompanyActionSuccess implements Action{
  type: CompanyActionTypes = CompanyActionTypes.SAVE_NEW_CAMPANY_SUCCESS;
  constructor(public payload: Company){}
}
export class SaveNewCompanyActionError implements Action{
  type: CompanyActionTypes = CompanyActionTypes.SAVE_NEW_CAMPANY_ERROR;
  constructor(public payload: string){}
}

//get all companies
export class GetAllComapaniesAction implements Action{
  type: CompanyActionTypes = CompanyActionTypes.GET_ALL_COMPANIES;
  constructor(public payload: any){}
}
export class GetAllComapaniesActionSuccess implements Action{
  type: CompanyActionTypes = CompanyActionTypes.GET_ALL_COMPANIES_SUCCESS;
  constructor(public payload: Array<Company>){}
}
export class GetAllComapaniesActionError implements Action{
  type: CompanyActionTypes = CompanyActionTypes.GET_ALL_COMPANIES_ERROR;
  constructor(public payload: string){}
}

//create form to update company
export class CreateFormUpdateCompanyAction implements Action{
  type: CompanyActionTypes = CompanyActionTypes.CREATE_FORM_UPDATE_COMPANY;
  constructor(public payload: Company){}
}
export class CreateFormUpdateCompanyActionSuccess implements Action{
  type: CompanyActionTypes = CompanyActionTypes.CREATE_FORM_UPDATE_COMPANY_SUCCESS;
  constructor(public payload: Company){}
}
export class CreateFormUpdateCompanyActionError implements Action{
  type: CompanyActionTypes = CompanyActionTypes.CREATE_FORM_UPDATE_COMPANY_ERROR;
  constructor(public payload: string){}
}

//update company
export class UpdateCompanyAction implements Action{
  type: CompanyActionTypes = CompanyActionTypes.UPDATE_COMPANY;
  constructor(public payload: Company){}
}
export class UpdateCompanyActionSuccss implements Action{
  type: CompanyActionTypes = CompanyActionTypes.UPDATE_COMPANY_SUCCESS;
  constructor(public payload: Company){}
}
export class UpdateCompanyActionError implements Action{
  type: CompanyActionTypes = CompanyActionTypes.UPDATE_COMPANY_ERROR;
  constructor(public payload: string){}
}

//delete a company
export class DeleteCompanyAction implements Action{
  type: CompanyActionTypes = CompanyActionTypes.DELETE_COMPANY;
  constructor(public payload: Company){}
}
export class DeleteCompanyActionSuccess implements Action{
  type: CompanyActionTypes = CompanyActionTypes.DELETE_COMPANY_SUCCESS;
  constructor(public payload: Company){}
}
export class DeleteCompanyActionError implements Action{
  type: CompanyActionTypes = CompanyActionTypes.DELETE_COMPANY_ERROR;
  constructor(public payload: string){}
}

export type CompanyActionUnion =
| CreateFormAddCompanyAction
| CreateFormAddCompanyActionSuccess
| CreateFormAddCompanyActionError
| SaveNewCompanyAction
| SaveNewCompanyActionSuccess
| SaveNewCompanyActionError
| GetAllComapaniesAction
| GetAllComapaniesActionSuccess
| GetAllComapaniesActionError
| CreateFormUpdateCompanyAction
| CreateFormUpdateCompanyActionSuccess
| CreateFormUpdateCompanyActionError
| UpdateCompanyAction
| UpdateCompanyActionSuccss
| UpdateCompanyActionError
| DeleteCompanyAction
| DeleteCompanyActionSuccess
| DeleteCompanyActionError;
