import { Company } from 'src/app/shared/models/company/company.model';
import { catchError } from 'rxjs/operators';
import { CompanyActionTypes } from './company.action.type';
import {
  CompanyActionUnion,
  GetAllComapaniesActionSuccess,
  GetAllComapaniesActionError,
} from './company.actions';
import { Observable, mergeMap, map, of } from 'rxjs';
import { Actions, createEffect, ofType } from '@ngrx/effects';
import { CompanyService } from './../../shared/services/company.service';
import { Injectable } from '@angular/core';

@Injectable()
export class CompanyGetEffects {
  constructor(
    private companyService: CompanyService,
    private companyActions: Actions
  ) {}

  geAllCompanyEffect: Observable<CompanyActionUnion> = createEffect(() =>
    this.companyActions.pipe(
      ofType(CompanyActionTypes.GET_ALL_COMPANIES),
      mergeMap((action: CompanyActionUnion) => {
        return this.companyService.getAllCompaniesService().pipe(
          map(
            (companies: Array<Company>) =>
              new GetAllComapaniesActionSuccess(companies)
          ),
          catchError((err) => of(new GetAllComapaniesActionError(err)))
        );
      })
    )
  );
}
