import { catchError } from 'rxjs/operators';
import { Project } from 'src/app/shared/models/project/project.model';
import { ProjectActionTypes } from './project.action.type';
import { ProjectActionUnion, GetAllProjectActionSuccess, GetAllProjectActionError } from './project.action';
import { Observable, mergeMap, map, of } from 'rxjs';
import { Actions, createEffect, ofType } from '@ngrx/effects';
import { ProjectService } from './../../shared/services/project.service';
import { Injectable } from '@angular/core';

@Injectable()
export class ProjectGetEffects {
  constructor(
    private projectService: ProjectService,
    private projectActions: Actions
  ) {}

  // get all project effect
  getAllProjectEffect : Observable<ProjectActionUnion> = createEffect(
    ()=> this.projectActions.pipe(
      ofType(ProjectActionTypes.GET_ALL_PROJECTS),
      mergeMap( (action: ProjectActionUnion) =>{
        return this.projectService.getAllProjectsService().pipe(
          map ( (projects: Array<Project>) => new GetAllProjectActionSuccess(projects)),
          catchError( err => of(new GetAllProjectActionError(err)))
        )
      })
    )
  );
}
