import { UserActionTypes } from './user.action.type';
import { Action } from '@ngrx/store';
import { User } from 'src/app/shared/models/user/user.model';
import { Project } from 'src/app/shared/models/project/project.model';

//get all user action
export class GetAllUsersAction implements Action {
  type: UserActionTypes = UserActionTypes.GET_ALL_USERS;
  constructor(public payload: any, public addressID: any) {}
}
export class GetAllUsersActionSuccess implements Action {
  type: UserActionTypes = UserActionTypes.GET_ALL_USERS_SUCCESS;
  constructor(public payload: Array<User>, public addressID: any) {}
}
export class GetAllUsersActionError implements Action {
  type: UserActionTypes = UserActionTypes.GET_ALL_USERS_ERROR;
  constructor(public payload: string, public addressID: any) {}
}

//form to add new user action
export class CreateFormAddUserAction implements Action {
  type: UserActionTypes = UserActionTypes.CREATE_FORM_ADD_USER;
  constructor(public payload: any, public addressID: any) {}
}
export class CreateFormAddUserActionSuccess implements Action {
  type: UserActionTypes = UserActionTypes.CREATE_FORM_ADD_USER_SUCCESS;
  constructor(public payload: any, public addressID: any) {}
}
export class CreateFormAddUserActionError implements Action {
  type: UserActionTypes = UserActionTypes.CREATE_FORM_ADD_USER_ERROR;
  constructor(public payload: string, public addressID: any) {}
}

// save new user action
export class SaveNewUserAction implements Action{
  type: UserActionTypes = UserActionTypes.SAVE_NEW_USER;
  constructor(public payload:User){}
}
export class SaveNewUserActionSuccess implements Action{
  type: UserActionTypes = UserActionTypes.SAVE_NEW_USER_SUCCESS;
  constructor(public payload:User){}
}
export class SaveNewUserActionError implements Action{
  type: UserActionTypes = UserActionTypes.SAVE_NEW_USER_ERROR;
  constructor(public payload: string){}
}

// delete user action
export class DeleteUserAction implements Action{
  type: UserActionTypes = UserActionTypes.DELETE_USER;
  constructor(public payload: User,  public addressID: any){}
}
export class DeleteUserActionSuccess implements Action{
  type: UserActionTypes = UserActionTypes.DELETE_USER_SUCCCESS;
  constructor(public payload: User,  public addressID: any){}
}
export class DeleteUserActionError implements Action{
  type: UserActionTypes = UserActionTypes.DELETE_USER_ERROR;
  constructor(public payload: string,  public addressID: any){}
}

// form to update user action
export class CreateFormUpdateUserAction implements Action{
  type: UserActionTypes = UserActionTypes.CREATE_FORM_UPDATE_USER;
  constructor(public payload: User,  public addressID: any){}
}
export class CreateFormUpdateUserActionSuccess implements Action{
  type: UserActionTypes = UserActionTypes.CREATE_FORM_UPDATE_USER_SUCCESS;
  constructor(public payload: User,  public addressID: any){}
}
export class CreateFormUpdateUserActionError implements Action{
  type: UserActionTypes = UserActionTypes.CREATE_FORM_UPDATE_USER_ERROR;
  constructor(public payload: string,  public addressID: any){}
}

//update user
export class UpdateUserAction implements Action{
  type: UserActionTypes = UserActionTypes.UPDATE_USER;
  constructor(public payload: User){}
}
export class UpdateUserActionSuccess implements Action{
  type: UserActionTypes = UserActionTypes.UPDATE_USER_SUCCESS;
  constructor(public payload: User){}
}
export class UpdateUserActionError implements Action{
  type: UserActionTypes = UserActionTypes.UPDATE_USER_ERROR;
  constructor(public payload: string){}
}

//get projects assigned to user
export class GetUser_s_Projects implements Action{
  type: UserActionTypes = UserActionTypes.GET_PROJECTS_BY_USER;
  constructor(public payload: any, public addressID: any){}
}
export class GetUser_s_ProjectsSuccess implements Action{
  type: UserActionTypes = UserActionTypes.GET_PROJECTS_BY_USER_SUCCESS;
  constructor(public payload: Array<Project>, public addressID: any){}
}
export class GetUser_s_ProjectsError implements Action{
  type: UserActionTypes = UserActionTypes.GET_PROJECTS_BY_USER_ERROR;
  constructor(public payload: string, public addressID: any){}
}

export type UserActionUnion =
  | GetAllUsersAction
  | GetAllUsersActionSuccess
  | GetAllUsersActionError
  | CreateFormAddUserAction
  | CreateFormAddUserActionSuccess
  | CreateFormAddUserActionError
  | SaveNewUserAction
  | SaveNewUserActionSuccess
  | SaveNewUserActionError
  | DeleteUserAction
  | DeleteUserActionSuccess
  | DeleteUserActionError
  | CreateFormUpdateUserAction
  | CreateFormUpdateUserActionSuccess
  | CreateFormUpdateUserActionError
  | UpdateUserAction
  | UpdateUserActionSuccess
  | UpdateUserActionError
  ;
