import { MsgState } from 'src/app/ngrx/msg.state';
import { Observable } from 'rxjs';
import { GetAllProjectAction } from './../../../ngrx/project/project.action';
import { ProjectState } from './../../../ngrx/project/project.state';
import { Component, OnInit } from '@angular/core';
import { Store } from '@ngrx/store';

@Component({
  selector: 'app-project-management',
  templateUrl: './project-management.component.html',
  styleUrls: ['./project-management.component.css'],
})
export class ProjectManagementComponent implements OnInit {
  constructor(private store: Store<{ projectReducerSelector: ProjectState }>) {}
  projectState$!: Observable<ProjectState>;
  msgState = MsgState;

  ngOnInit(): void {
    this.store.dispatch(new GetAllProjectAction());
    this.projectState$ = this.store.select('projectReducerSelector');
  }
}
