import { DeleteProjectAction, GetAllProjectAction } from './../../../../ngrx/project/project.action';
import { ProjectState } from './../../../../ngrx/project/project.state';
import { MsgState } from 'src/app/ngrx/msg.state';
import { Router } from '@angular/router';
import { Project } from 'src/app/shared/models/project/project.model';
import { Component, OnInit, Input } from '@angular/core';
import { Store } from '@ngrx/store';

@Component({
  selector: 'app-projects-list',
  templateUrl: './projects-list.component.html',
  styleUrls: ['./projects-list.component.css']
})
export class ProjectsListComponent implements OnInit {

  constructor(private router: Router, private store : Store<{projectReducerSelector: ProjectState}>) { }

  @ Input () inputProjectsList!: Array<Project>;
  ngOnInit(): void {
  }

  onEditProject(project: Project){
    this.router.navigateByUrl("/project-update/"+project.projectID);
  }
  onProjectDelete(project:Project){
    if(window.confirm(MsgState.CONFIRM_DEL)){
      this.store.dispatch(new DeleteProjectAction(project))
    }
  }

  projectName!: string;

  onSearch1() {
    if(this.projectName==''){
      this.store.dispatch(new GetAllProjectAction()); //refresh
    }
    else{
      this.inputProjectsList = this.inputProjectsList.filter((project: Project) => {
        return project.projectName
          .toLocaleLowerCase()
          .match(this.projectName.toLocaleLowerCase());
      });
    }
  }

  userLastname!:string;
  onSearch2() {
    if(this.userLastname==''){
      this.store.dispatch(new GetAllProjectAction()); //refresh
    }
    else{
      this.inputProjectsList = this.inputProjectsList.filter((project: Project) => {
        return project.user.lastname
          .toLocaleLowerCase()
          .match(this.userLastname.toLocaleLowerCase());
      });
    }
  }

  companyName!:string;
  onSearch3() {
    if(this.companyName==''){
      this.store.dispatch(new GetAllProjectAction()); //refresh
    }
    else{
      this.inputProjectsList = this.inputProjectsList.filter((project: Project) => {
        return project.company.companyName
          .toLocaleLowerCase()
          .match(this.companyName.toLocaleLowerCase());
      });
    }
  }
}
