import { HttpErrorResponse } from "@angular/common/http";
import { Injectable } from "@angular/core";
import { throwError } from "rxjs";

@Injectable({
  providedIn:"root"
})
export class MyServerErrorHandler{

  handleError(err: HttpErrorResponse) {
    if (err.status === 0) {
      console.error('error has occurred:', err.error);
    } else {
      console.error(
        'Backend returned code ${error.status}, body was:',
        err.error
      );
    }

    return throwError(() => {
      new Error('something went wrong, try again');
    });
  }
}
